C     PROGRAM TO REDUCE INTENSITY DATA(I.E., L-P, BACKGROUND AND 
C     ABSORPTION)
      CHARACTER*80, CFIL,CFIL1, TIT,TITLE,FNAME1 
      PARAMETER(IDIM=20000)
      DIMENSION FOBS(IDIM),AA(IDIM),B(80),C(IDIM),D(IDIM),E(IDIM),F
     *(IDIM),II(IDIM,3),ILB(IDIM),IIN(IDIM),IRB(IDIM),ABSO(IDIM),I1(80)
     *,F1(80),NP(IDIM),BB(IDIM),THETA(IDIM),THE(IDIM)
       DATA S1,S3/'N','I'/


      CALL SWGTIT (' "Reduce" Data Reduction Software - CAD4')
      CALL SWGTIT (' Reduce - Created by Dr. R. Saravanan')
      CALL SWGHLP ('Processing of Raw Intensities collected with CAD-4 d
     *iffractometer.||By. Dr. R. Saravanan|The Madura College|Madurai - 
     *625 011|website: www.saraxraygroup.net|email: saragow@dataone.in|p
     *h.+91 94430 69852')

         CALL SWGCLR (1.0,1.0,0.7, 'BACK')
         CALL WGINI  ('FORM',10034)
         CALL SWGWIN(10,0,1500,800)
         CALL WGBAS (10034, 'FORM', 222)
       CALL SWGCLR (0.7,0.2,0.5, 'BACK')
       CALL SWGCLR (0.9,0.85,0.8, 'FORE')
         CALL SWGWIN(250,00,350,20)
        CALL  WGLAB  (222, ' "Reduce"   Processing of Raw Intensities - 
     *CAD-4',1181)
         CALL SWGJUS('CENTER','LABEL') 
         CALL SWGCLR (0.8,0.9,0.8, 'BACK')
         CALL SWGCLR (0.1,0.1,0.1, 'FORE')
         CALL SWGWIN(10,40,400,20)
         CALL  WGLAB  (222, ' Title', 111)
         CALL WGLTXT (222, ' Title ',' ',70, 111)

       CALL SWGWIN(10,80,400,20)
       CALL  WGLAB  (222, 'Cell a', 121)
       CALL WGLTXT (222, ' Cell a ',' ',30, 121)

       CALL SWGWIN(10,110,400,20)
       CALL  WGLAB  (222, 'Cell b', 131)
       CALL WGLTXT (222, ' Cell b ',' ',30, 131)

       CALL SWGWIN(10,140,400,20)
       CALL  WGLAB  (222, 'Cell c', 141)
       CALL WGLTXT (222, ' Cell c ',' ',30, 141)

       CALL SWGWIN(10,170,400,20)
       CALL  WGLAB  (222, 'Alpha', 151)
       CALL WGLTXT (222, ' Alpha ',' ',30, 151)

       CALL SWGWIN(10,200,400,20)
       CALL  WGLAB  (222, 'Beta', 161)
       CALL WGLTXT (222, ' Beta ',' ',30, 161)

       CALL SWGWIN(10,230,400,20)
       CALL  WGLAB  (222, 'Gamma', 171)
       CALL WGLTXT (222, ' Gamma ',' ',30, 171)

       CALL SWGWIN(10,260,400,20)
       CALL  WGLAB  (222, 'Lambda', 181)
       CALL WGLTXT (222, ' Lambda ',' ',30, 181)

       CALL SWGWIN(10,290,400,20)
       CALL  WGLAB  (222, 'Monochromator angle', 191)
       CALL WGLTXT (222, ' Monochromator angle ',' ',30, 191)

         CALL SWGWIN(150,200,00,0)
         CALL WGFIL(222, 'CAD4 Intensity File',' ','*.*',201)

         CALL SWGWIN(250,200,00,0)
         CALL WGFIL(222, 'Abs.Corr File',' ','*.*',211)
 
          CALL SWGWIN(420,40,400,540)
         CALL SWGCLR (0.75,0.8,0.9, 'BACK')
         CALL SWGCLR (0.2,0.0,0.1, 'FORE')
         call wgstxt(222,25,200,204)
         call swgtxt(204, 'This software  is a GUI version of Reduce pro
     *gram cited')
         call swgtxt(204,'in the website of Dr. R. Saravanan (www.saraxr
     *aygroup.net).')
         call swgtxt(204, 'Hence, first read and understand the help fil
     *es of the dos')
       call swgtxt(204,'version. Additional support is provided here.')
        call swgtxt(204, '===========================================')
         call swgtxt(204,'The Raw Intensity file to be processed can be 
     *selected by clicking')
        call swgtxt(204,'|File|CAD4 Intensity File| from the main menu b
     *ar.') 
         call swgtxt(204,'============================================')
         call swgtxt(204,'The format of raw Intensity file is as below;'
     *)
         call swgtxt(204,'============================================')
         call swgtxt(204,'e.g., ')
         call swgtxt(204,' 1     1   -2   -2   -2 I*****   0.21  -3   70
     *3 100311   580')
         call swgtxt(204,' 2     1  17.834  -41.712   -1.320   57.376  1
     *.384     65  0') 
         call swgtxt(204,' 1     2   -1   -1   -3 I*****  -0.08  -3   31
     *4  42576   210') 
         call swgtxt(204,' 2     2  17.057  -35.306   10.648   18.816  1
     *.384     97  0') 
         call swgtxt(204,'	"	"	"')
         call swgtxt(204,'	"	"	"')
         call swgtxt(204,'	"	"	"')
         call swgtxt(204,'	"	"	"')
         call swgtxt(204,'    FINISH')
         call swgtxt(204,'============================================')

         call swgtxt(204,'(The final line should be FINISH).')
         call swgtxt(204,'The file containing absorption correction valu
     *es can be')
         call swgtxt(204,'selected by clicking')
       call swgtxt(204,'|File|Abs.Corr File| from the main menu bar.') 
         call swgtxt(204,'============================================')
         call swgtxt(204,'The format of absorption correction file is as
     *below;')
         call swgtxt(204,'============================================')
         call swgtxt(204,'It has two columns. First column contains the 
     *angle (starting from 0).')
         call swgtxt(204,'The second column contains the absorption corr
     *ection value')
      call swgtxt(204,'for spheres listed in International tables.')
         call swgtxt(204,'A total of 19 lines are allowed.') 
         call swgtxt(204,'============================================')
         call swgtxt(204,'Example file is given below')
C=============================================================
         call swgtxt(204,' 0 49.449')
         call swgtxt(204,' 5 47.282')
         call swgtxt(204,'10 42.459')
         call swgtxt(204,'15 36.536')
         call swgtxt(204,'20 31.102')
         call swgtxt(204,'25 26.446')
         call swgtxt(204,'30 21.789')
         call swgtxt(204,'35 17.701') 
         call swgtxt(204,'40 17.312')
         call swgtxt(204,'45 15.334')
         call swgtxt(204,'50 13.845')
         call swgtxt(204,'55 12.556')
         call swgtxt(204,'60 11.556')
         call swgtxt(204,'65 10.756')
         call swgtxt(204,'70 10.064')
         call swgtxt(204,'75  9.557')
         call swgtxt(204,'80  9.180')
         call swgtxt(204,'85  8.960')
         call swgtxt(204,'90  8.871')
         call swgtxt(204,'============================================')

          call swgtxt(204,'   ------------------------------------------
     *-------')
          call swgtxt(204,'   THIS PROGRAM PRODUCES OUTPUT FILE AS FOLLO
     *WS;')  
          call swgtxt(204,'   (File name can be given through key board
     *.)')  
      call swgtxt(204,'H    K   L      A*(ABS.CORR)         LP        IO
     *BS        SIGIobs      Fobs')
      call swgtxt(204,'SIGFobs     WTG')
           call swgtxt(204,'   ------------------------------------------
     *-------')
 
           call swgwin(0,350,165,20)
           CALL  WGLAB  (222, ' Give output file name', 501)
           call swgwin(0,370,360,20)
           call  wglab  (222, '(h   k   l       A*(abs. corr)   Lp    Fo
     *bs    SigFobs   Wtg)',501) 
           CALL SWGWIN(0,390,360,20)
           CALL WGLTXT (222, ' Output  ',' ',30, 501)

  
          CALL SWGWIN(620,575,200,20)
         CALL WGOK (222, IDD1)
         CALL SWGWIN(620,600,200,20)
         CALL WGQUIT (222, IDD2)

       CALL WGFIN
       CALL GWGTXT(501, FNAME1)

       CALL GWGTXT(111, TIT)
       CALL GWGFLT (121, ACEL1)
       CALL GWGFLT (131, ACEL2)
       CALL GWGFLT (141, ACEL3)
       CALL GWGFLT (151, ALPA)
       CALL GWGFLT (161, BET)
       CALL GWGFLT (171, GAMA)
       CALL GWGFLT (181, ALMDA1)
       CALL GWGFLT (191, THEM1)
       TITLE=TIT
       CELL1=ACEL1
       CELL2=ACEL2
       CELL3=ACEL3
       ALPHA=ALPA
       BETA=BET
       GAMMA=GAMA
       ALMDA=ALMDA1
       THEM=THEM1
 
          OPEN(8,FILE=FNAME1)

        OPEN(4,FILE='TEMP1')

       CALL GWGFIL(201,CFIL)
       OPEN(2,FILE=CFIL)

       CALL GWGFIL(211,CFIL1)
       OPEN(3,FILE=CFIL1)

      PHI=3.141592
1010  READ(2,1000,END=3333)(B(I),I=1,61)
1000  FORMAT(61A1)
      IF(B(26).EQ.S1.OR.B(26).EQ.S3)GO TO 1201
      GO TO 1010
1201  WRITE(4,1500)B(12),B(13),B(14),B(17),B(18),B(19),B(22)
     *,B(23),B(24),B(40),B(41),B(42),B(45),B(46),B(47),B(48),B(50),B(
     *51),B(52),B(53),B(54),B(55),B(58),B(59),B(60),B(61)
1500  FORMAT(26A1)
      GO TO 1010
3333  WRITE(4,*)'99'
      CLOSE(2)
      CLOSE(4)
      OPEN(3,FILE=cfil1)
      OPEN(4,FILE='TEMP1')

      WRITE(8,5)TITLE
 5    FORMAT(20A4)
      NREFL=1
      WRITE(8,10)CELL1,CELL2,CELL3,ALPHA,BETA,GAMMA,ALMDA,THEM
10    FORMAT(3F10.5)
      READ(3,20)(I1(I),F1(I),I=1,19)
      WRITE(8,20)(I1(I),F1(I),I=1,19)
20    FORMAT(I4,F8.3)
      WRITE(8,*)' ------------------------------------------------------
     *----------------------------------------'
      WRITE(8,210)
 210  FORMAT('   H   K   L    A*        LP     IOBS          SIG(IOBS)         
     *     FOBS       SIG(FOBS)    WGT')
      WRITE(8,*)' ------------------------------------------------------
     *----------------------------------------'
      ALPHA=ALPHA*(PHI/180.0)
      BETA=BETA*(PHI/180.0)
      GAMMA=GAMMA*(PHI/180.0)
      THEM=(2.0*PHI/180.0)*THEM  
50    READ(4,60)II1,II2,II3,NP1,ILB1,IIN1,IRB1 
 60   FORMAT(4I3,I4,I6,I4)
       IF(II1.EQ.99)GO TO 1100
       CONTINUE
       IF (NP1.EQ.0)GO TO 50
       GO TO 2601
2601   IF(IIN1.LE.0)GO TO 50
       CONTINUE
      TEST1=IIN1-2*(IRB1+ILB1)
      IF(TEST1)50,50,2501
2501  CONTINUE
      II(NREFL,1)=II1
      II(NREFL,2)=II2
      II(NREFL,3)=II3
      ILB(NREFL)=ILB1
      IIN(NREFL)=IIN1
      IRB(NREFL)=IRB1
      NP(NREFL)=NP1
        A1=II(NREFL,1)
        A2=II(NREFL,2)
        A3=II(NREFL,3)
 	TE1=A1**2/CELL1**2
 	TE2=A2**2/CELL2**2
 	TE3=A3**2/CELL3**2
        ST1=SIN(ALPHA)**2
        ST2=SIN(BETA)**2
        ST3=SIN(GAMMA)**2
	TE4=((2.0*A1*A2)/(CELL1*CELL2))*(COS(ALPHA)*COS(BETA)-COS
     *	(GAMMA))
	TE5=((2.0*A2*A3)/(CELL3*CELL2))*(COS(GAMMA)*COS(BETA)-COS
     *  (ALPHA))
	TE6=((2.0*A1*A3)/(CELL1*CELL3))*(COS(ALPHA)*COS(GAMMA)-COS
     *  (BETA))
        DENO1=COS(ALPHA)**2
        DENO2=COS(BETA)**2
        DENO3=COS(GAMMA)**2
	DENO4=2.0*COS(ALPHA)*COS(BETA)*COS(GAMMA) 
        SIN2L=0.25*((TE1*ST1+TE2*ST2+TE3*ST3+TE4+TE5+TE6)/(1.0-DENO1-
     *DENO2-DENO3+DENO4))
        SINTSF=SQRT(SIN2L)*ALMDA
	IF(SINTSF.GT.1.0)GO TO 100
        COS2T=(1.0-SINTSF*SINTSF)
        COST=SQRT(COS2T)
        THETA(NREFL)=ATAN(SINTSF/COST)
        THE(NREFL)=THETA(NREFL)*180.0/PHI
  	IF(THE(NREFL)-90.0)181,181,50
181   DO 130 K=1,19
      IF(I1(K)-THE(NREFL))130,140,140
 130  CONTINUE
 140  DEL=(F1(K-1)-F1(K))/(I1(K)-I1(K-1))
      IF(DEL)171,111,171
111   ABSOR=F1(K)
      GO TO 191
171   ABSOR=F1(K)+DEL*(I1(K)-THE(NREFL))
191   AA(NREFL)=ABSOR
      IF (SIN(THETA(NREFL)))1212, 50, 1212
1212  CONTINUE
       STN=2.0*THETA(NREFL)
       ST1=COS(THEM)*COS(THEM)
       ST2=COS(STN)*COS(STN)
       ST3=2.0*SIN(STN)
       ST3=SIN(THETA(NREFL))
       POLAR=((1.0+ST2)/ST3)*ST1/(1.0+ST1)
C       POLAR=(COS(THEM)+COS(THETA(NREFL))**2)/(1+COS(THEM))/SIN(THETA
C     *(NREFL))
C       WRITE(6,*)POLAR,ST2,ST3
       SUM=NP(NREFL)
       ANM=ABS(SUM)
       AN=20.11
       ABSO(NREFL)=13.71*AN/ANM
      IF(NP(NREFL))170,180,180
 170  ABSO(NREFL)=ABSO(NREFL) 
 180  BLG=ILB(NREFL)*ABSO(NREFL)
      TOT=IIN(NREFL)*ABSO(NREFL)
      BRG=IRB(NREFL)*ABSO(NREFL)
      BB(NREFL)=POLAR
      TEST=TOT-2*(BLG+BRG)
      IF(TEST)100,100,144
144   TOTAL=(TOT-2.*(BLG+BRG))*ABSOR/POLAR
      IF(TOTAL)100,100,146
146   TETE=TOT+4.0*(BLG+BRG)
      SIGT=SQRT(TETE)*ABSO(I)*ABSOR/POLAR
      WRITE(6,*)TETE,ABSOR,ABSO(I),POLAR,SIGT
      IF(SIGT)100,100,147
147   FOBS(NREFL)=SQRT(ABS(TOTAL))
      IF(FOBS(NREFL))100,100,148
148   SIGF=SIGT/(2.*FOBS(NREFL))
      IF(SIGF)100,100,456
456   WTG=1.0/(SIGF**2)
      C(NREFL)=TOTAL
      D(NREFL)=SIGT
      E(NREFL)=SIGF
      F(NREFL)=WTG
       WRITE(8,230)II(NREFL,1),II(NREFL,2),II(NREFL,3),AA(NREFL),BB
     *(NREFL),C(NREFL),D(NREFL),FOBS(NREFL),E(NREFL),F(NREFL)
230   FORMAT(3I4,2X,F7.2,2X,F7.2,2X,E12.5,2X,E12.5,1X,F12.5,F10.2,2X,
     *F12.4)
 100  CONTINUE
      NREFL=NREFL+1
      GO TO 50
1100  CONTINUE
      WRITE(8,*)' ------------------------------------------------------
     *----------------------------------------'
        WRITE(8,3492)
        WRITE(6,3492)
3492    FORMAT(' PROGRAM WRITTEN AND STABILIZED BY')
	WRITE(8,*)('****************************************************
     ******')
        WRITE(8,*)('DR. R. SARAVANAN, M.SC., M.PHIL., PH.D.')
        WRITE(8,*)('LECTURER (SS)')
        WRITE(8,*)('DEPT. OF PHYSICS')
        WRITE(8,*)('THE MADURA COLLEGE')
        WRITE(8,*)('MADURAI - 625 011')
        WRITE(8,*)('TAMIL NADU')
        WRITE(8,*)('INDIA')
        WRITE(8,*)('PH.      :')
        WRITE(8,*)('OFFICE   : +91-452-2673354 X:211')
        WRITE(8,*)('RESIDENCE: +91-452-2459000')
        WRITE(8,*)('CELL     : +91 94430 69852')
        WRITE(8,*)('EMAILS   : SARAGOW@DATAONE.IN; SARAGOW@SARAXRAYGROUP
     *.NET')
        WRITE(8,*)('WEBSITE  : WWW.SARAXRAYGROUP.NET')
	WRITE(8,*)('****************************************************
     ******')
	WRITE(6,*)('****************************************************
     ******')
        WRITE(6,*)('DR. R. SARAVANAN, M.SC., M.PHIL., PH.D.')
        WRITE(6,*)('LECTURER (SS)')
        WRITE(6,*)('DEPT. OF PHYSICS')
        WRITE(6,*)('THE MADURA COLLEGE')
        WRITE(6,*)('MADURAI - 625 011')
        WRITE(6,*)('TAMIL NADU')
        WRITE(6,*)('INDIA')
        WRITE(6,*)('PH.      :')
        WRITE(6,*)('OFFICE   : +91-452-2673354 X:211')
        WRITE(6,*)('RESIDENCE: +91-452-2459000')
        WRITE(6,*)('CELL     : +91 94430 69852')
        WRITE(6,*)('EMAILS   : SARAGOW@DATAONE.IN; SARAGOW@SARAXRAYGROUP
     *.NET')
        WRITE(6,*)('WEBSITE  : WWW.SARAXRAYGROUP.NET')
	WRITE(6,*)('****************************************************
     ******')
      CLOSE(8)
      CLOSE(3)
      CLOSE(4)
      STOP
      END
